=== debian/changelog ===
openorienteering-mapper (0.6.7-1) unstable; urgency=medium

  * [ffc784] New upstream release

 -- Gaudenz Steinlin <gaudenz@debian.org>  Thu, 22 Dec 2016 08:55:05 +0100

openorienteering-mapper (0.6.6-1) unstable; urgency=medium

  * [9a1799] New upstream release (Closes: #847408)

 -- Gaudenz Steinlin <gaudenz@debian.org>  Tue, 13 Dec 2016 15:52:35 +0100
